commit 73d3b73c090557b9f11cef78623cf11b81e9c7a9
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Sat Nov 29 21:02:12 2025 +0000

    track tainted values through hintsdb storage

diff --git a/src/src/acl.c b/src/src/acl.c
index bc4f6af6d..7ec3a898c 100644
--- a/src/src/acl.c
+++ b/src/src/acl.c
@@ -2826,7 +2826,7 @@ if (!dbd)
   {
   HDEBUG(D_acl) debug_printf_indent("ratelimit initializing new key's rate data\n");
   dbd = &dbdb->dbd;
-  dbd->time_stamp = tv.tv_sec;
+  dbd->gen.time_stamp = tv.tv_sec;
   dbd->time_usec = tv.tv_usec;
   dbd->rate = count;
   }
@@ -2876,7 +2876,7 @@ else
 
   double this_time = (double)tv.tv_sec
                    + (double)tv.tv_usec / 1000000.0;
-  double prev_time = (double)dbd->time_stamp
+  double prev_time = (double)dbd->gen.time_stamp
                    + (double)dbd->time_usec / 1000000.0;
 
   /* We must avoid division by zero, and deal gracefully with the clock going
@@ -2893,7 +2893,7 @@ else
   using the smoothing factor a. In order to measure sized events, multiply the
   instantaneous rate by the count of bytes or recipients etc. */
 
-  dbd->time_stamp = tv.tv_sec;
+  dbd->gen.time_stamp = tv.tv_sec;
   dbd->time_usec = tv.tv_usec;
   dbd->rate = (1 - a) * count / i_over_p + a * dbd->rate;
 
@@ -3048,7 +3048,7 @@ dbd = dbfn_read_with_length(dbm, key, NULL);
 now = time(NULL);
 if (dbd)		/* an existing record */
   {
-  time_t diff = now - dbd->time_stamp;	/* time since the record was written */
+  time_t diff = now - dbd->gen.time_stamp;  /* time since record was written */
 
   if (before ? diff >= interval : diff < interval)
     yield = OK;
@@ -3057,13 +3057,13 @@ if (dbd)		/* an existing record */
     { HDEBUG(D_acl) debug_printf_indent("seen db not written (readonly)\n"); }
   else if (mode == SEEN_WRITE || !before)
     {
-    dbd->time_stamp = now;
+    dbd->gen.time_stamp = now;
     dbfn_write(dbm, key, dbd, sizeof(*dbd));
     HDEBUG(D_acl) debug_printf_indent("seen db written (update)\n");
     }
   else if (diff >= refresh)
     {
-    dbd->time_stamp = now - interval;
+    dbd->gen.time_stamp = now - interval;
     dbfn_write(dbm, key, dbd, sizeof(*dbd));
     HDEBUG(D_acl) debug_printf_indent("seen db written (refresh)\n");
     }
@@ -3072,7 +3072,7 @@ else
   {			/* No record found, yield always FAIL */
   if (mode != SEEN_READONLY)
     {
-    dbdata_seen d = {.time_stamp = now};
+    dbdata_seen d = {.gen = {.time_stamp = now}};
     dbfn_write(dbm, key, &d, sizeof(*dbd));
     HDEBUG(D_acl) debug_printf_indent("seen db written (create)\n");
     }
diff --git a/src/src/dbfn.c b/src/src/dbfn.c
index 3ed78901b..0a05524e1 100644
--- a/src/src/dbfn.c
+++ b/src/src/dbfn.c
@@ -410,6 +410,7 @@ void * yield;
 EXIM_DATUM key_datum, result_datum;
 uschar * key_copy = store_get(klen, key);
 unsigned dlen;
+BOOL tainted;
 
 memcpy(key_copy, key, klen);
 
@@ -426,13 +427,17 @@ if (!exim_dbget(dbblock->dbptr, &key_datum, &result_datum))
   return NULL;
   }
 
-/* Assume the data store could have been tainted.  Properly, we should
-store the taint status with the data. */
-
 dlen = exim_datum_size_get(&result_datum);
 DEBUG(D_hints_lookup) debug_printf_indent("dbfn_read: size %u return\n", dlen);
 
-yield = store_get(dlen+1, hintsdb ? GET_TAINTED : GET_UNTAINTED);
+/* Hintsdb uses store the taint of the payload of the value in the value.
+For non-hints uses we have no provenance, so assume untainted */
+
+tainted = hintsdb
+  ? ((dbdata_generic *) exim_datum_data_get(&result_datum))->tainted
+  : FALSE;
+
+yield = store_get(dlen+1, tainted ? GET_TAINTED : GET_UNTAINTED);
 memcpy(yield, exim_datum_data_get(&result_datum), dlen);
 ((uschar *)yield)[dlen] = '\0';
 if (length) *length = dlen;
@@ -498,6 +503,8 @@ return NULL;
 *************************************************/
 
 /*
+All callers are writing a hintsdb record.
+
 Arguments:
   dbblock   a pointer to an open database block
   key       the key of the record to be written
@@ -509,7 +516,7 @@ Returns:    the yield of the underlying dbm or db "write" function. If this
 */
 
 int
-dbfn_write(open_db *dbblock, const uschar *key, void *ptr, int length)
+dbfn_write(open_db * dbblock, const uschar * key, void * ptr, int length)
 {
 EXIM_DATUM key_datum, value_datum;
 dbdata_generic *gptr = (dbdata_generic *)ptr;
@@ -518,6 +525,7 @@ uschar * key_copy = store_get(klen, key);
 
 memcpy(key_copy, key, klen);
 gptr->time_stamp = time(NULL);
+gptr->tainted = is_tainted(ptr);
 
 DEBUG(D_hints_lookup)
   debug_printf_indent("dbfn_write: key=%s datalen %d\n", key, length);
diff --git a/src/src/deliver.c b/src/src/deliver.c
index c978e67b5..cf3a41156 100644
--- a/src/src/deliver.c
+++ b/src/src/deliver.c
@@ -2932,7 +2932,7 @@ while (addr_local)
 	DEBUG(D_retry)
 	  {
 	  debug_printf("retry record exists: age=%s ",
-	    readconf_printtime(now - retry_record->time_stamp));
+	    readconf_printtime(now - retry_record->gen.time_stamp));
 	  debug_printf("(max %s)\n", readconf_printtime(retry_data_expire));
 	  debug_printf("  time to retry = %s expired = %d\n",
 	    readconf_printtime(retry_record->next_try - now),
@@ -2941,7 +2941,7 @@ while (addr_local)
 
 	if (f.queue_running && !f.deliver_force)
 	  {
-	  ok = (now - retry_record->time_stamp > retry_data_expire)
+	  ok = (now - retry_record->gen.time_stamp > retry_data_expire)
 	    || (now >= retry_record->next_try)
 	    || retry_record->expired;
 
@@ -7827,7 +7827,7 @@ while (addr_new)           /* Loop until all addresses dealt with */
       {
       domain_retry_record = dbfn_read(dbm_file, addr->domain_retry_key);
       if (  domain_retry_record
-	 && now - domain_retry_record->time_stamp > retry_data_expire
+	 && now - domain_retry_record->gen.time_stamp > retry_data_expire
 	 )
 	{
 	DEBUG(D_deliver|D_retry)
@@ -7837,7 +7837,7 @@ while (addr_new)           /* Loop until all addresses dealt with */
 
       address_retry_record = dbfn_read(dbm_file, addr->address_retry_key);
       if (  address_retry_record
-	 && now - address_retry_record->time_stamp > retry_data_expire
+	 && now - address_retry_record->gen.time_stamp > retry_data_expire
 	 )
 	{
 	DEBUG(D_deliver|D_retry)
@@ -7851,7 +7851,7 @@ while (addr_new)           /* Loop until all addresses dealt with */
 				  addr->address_retry_key, sender_address);
 	address_retry_record = dbfn_read(dbm_file, altkey);
 	if (  address_retry_record
-	   && now - address_retry_record->time_stamp > retry_data_expire)
+	   && now - address_retry_record->gen.time_stamp > retry_data_expire)
 	  {
 	  DEBUG(D_deliver|D_retry)
 	    debug_printf_indent("address<sender> retry record present but expired\n");
diff --git a/src/src/enq.c b/src/src/enq.c
index 8129b3b2b..372607daf 100644
--- a/src/src/enq.c
+++ b/src/src/enq.c
@@ -53,7 +53,7 @@ if (!(dbm_file = dbfn_open(US"misc", O_RDWR|O_CREAT, &dbblock, TRUE, TRUE)))
 proceed with the connection unless the record is very old. */
 
 serial_record = dbfn_read_enforce_length(dbm_file, key, sizeof(dbdata_serialize));
-if (serial_record && time(NULL) - serial_record->time_stamp < 6*60*60)
+if (serial_record && time(NULL) - serial_record->gen.time_stamp < 6*60*60)
   {
   if (serial_record->count >= lim)
     {
diff --git a/src/src/exim_dbutil.c b/src/src/exim_dbutil.c
index 26dca7dbd..2c03be1c5 100644
--- a/src/src/exim_dbutil.c
+++ b/src/src/exim_dbutil.c
@@ -380,10 +380,7 @@ if (exim_lockfile_needed())
   exclusive access to the database, so we can go ahead and open it. */
   }
 
-if ((dbmdb
-    ? asprintf(CSS &filename, "%s", name)
-    : asprintf(CSS &filename, "%s/%s", dname, name)
-    ) < 0) return NULL;
+if (asprintf(CSS &filename, "%s", name) < 0) return NULL;
 
 if (!(dbblock->dbptr = dbblock->readonly && !exim_lockfile_needed()
 		      ? exim_dbopen_multi(filename, dname, flags, 0)
@@ -461,6 +458,7 @@ EXIM_DATUM key_datum, result_datum;
 int klen = Ustrlen(key) + 1;
 uschar * key_copy = store_get(klen, key);
 unsigned dlen;
+BOOL tainted;
 
 memcpy(key_copy, key, klen);
 
@@ -475,7 +473,15 @@ if (!exim_dbget(dbblock->dbptr, &key_datum, &result_datum)) return NULL;
 we should store the taint status along with the data. */
 
 dlen = exim_datum_size_get(&result_datum);
-yield = store_get(dlen, GET_TAINTED);
+
+/* Hintsdb uses store the taint of the payload of the value in the value.
+For non-hints uses we have no provenance, so assume untainted */
+
+tainted = dbmdb
+  ? FALSE
+  : ((dbdata_generic *) exim_datum_data_get(&result_datum))->tainted;
+
+yield = store_get(dlen, tainted ? GET_TAINTED : GET_UNTAINTED);
 memcpy(yield, exim_datum_data_get(&result_datum), dlen);
 DEBUG(D_hints_lookup) debug_printf_indent("dbfn_read: size %u return\n", dlen);
 if (length) *length = dlen;
@@ -733,7 +739,33 @@ for (uschar * key = dbfn_scan(dbm, TRUE, &cursor);
 	int dlen = length = sizeof(dbdata_generic);
 
 	printf("%s %s\n", print_time(recp->time_stamp), keybuffer);
-	printf("%s\n", string_sprintf("%.*q\n", dlen, dp));
+	if (  Ustrncmp(keybuffer, "etrn-", 5) == 0
+	   || Ustrncmp(keybuffer, "tpt-serialize-", 14) == 0
+	   || Ustrncmp(keybuffer, "host-serialize-", 15) == 0
+	   )
+	  printf("serialize %.*s: %d running\n",
+		  (int)(Ustrchr(keybuffer, '-') - keybuffer), keybuffer,
+		  ((dbdata_serialize *)recp)->count);
+	else
+	  {
+	  uschar * s = keybuffer + Ustrlen(keybuffer) - 5;
+	  if (s > keybuffer && Ustrcmp(s, ".EHLO") == 0)
+	    {
+	    ehlo_resp_precis * erp = &((dbdata_ehlo_resp *)recp)->data;
+
+	    printf("helo/ehlo %.*s clr %04x/%04x cry %04x/%04x",
+		    (int)(s - keybuffer), keybuffer,
+		    erp->cleartext_features, erp->cleartext_auths,
+		    erp->crypted_features,   erp->crypted_auths);
+
+	    if (sizeof(*erp) > 4 * sizeof(unsigned short))
+	      printf(" lim %05d/%05d/%05d",
+		erp->limit_mail, erp->limit_rcpt, erp->limit_rcptdom);
+	    putchar('\n');
+	    }
+	  else
+	    printf("%s\n", string_sprintf("%.*q\n", dlen, dp));
+	  }
 	break;
 	}
 
@@ -745,7 +777,7 @@ for (uschar * key = dbfn_scan(dbm, TRUE, &cursor);
 	if (length == sizeof(dbdata_callout_cache_address))
 	  {
 	  printf("%s %s callout=%s\n",
-	    print_time(((dbdata_generic *)value)->time_stamp),
+	    print_time(callout->gen.time_stamp),
 	    keybuffer,
 	    print_cache(callout->result));
 	  }
@@ -755,7 +787,7 @@ for (uschar * key = dbfn_scan(dbm, TRUE, &cursor);
 	else if (length == sizeof(dbdata_callout_cache))
 	  {
 	  printf("%s %s callout=%s postmaster=%s",
-	    print_time(((dbdata_generic *)value)->time_stamp),
+	    print_time(callout->gen.time_stamp),
 	    keybuffer,
 	    print_cache(callout->result),
 	    print_cache(callout->postmaster_result));
@@ -775,7 +807,7 @@ for (uschar * key = dbfn_scan(dbm, TRUE, &cursor);
 	  ratelimit = (dbdata_ratelimit *)value;
 	  rate_unique = (dbdata_ratelimit_unique *)value;
 	  printf("%s.%06d rate: %10.3f epoch: %s size: %u key: %s\n",
-	    print_time(ratelimit->time_stamp),
+	    print_time(ratelimit->gen.time_stamp),
 	    ratelimit->time_usec, ratelimit->rate,
 	    print_time(rate_unique->bloom_epoch), rate_unique->bloom_size,
 	    keybuffer);
@@ -784,7 +816,7 @@ for (uschar * key = dbfn_scan(dbm, TRUE, &cursor);
 	  {
 	  ratelimit = (dbdata_ratelimit *)value;
 	  printf("%s.%06d rate: %10.3f key: %s\n",
-	    print_time(ratelimit->time_stamp),
+	    print_time(ratelimit->gen.time_stamp),
 	    ratelimit->time_usec, ratelimit->rate,
 	    keybuffer);
 	  }
@@ -797,7 +829,7 @@ for (uschar * key = dbfn_scan(dbm, TRUE, &cursor);
 
       case type_seen:
 	seen = (dbdata_seen *)value;
-	printf("%s\t%s\n", keybuffer, print_time(seen->time_stamp));
+	printf("%s\t%s\n", keybuffer, print_time(seen->gen.time_stamp));
 	break;
 
       case type_dbm:
@@ -1014,8 +1046,10 @@ for(; (reset_point = store_mark()); store_reset(reset_point))
 	    ratelimit = (dbdata_ratelimit *)record;
 	    switch(fieldno)
 	      {
-	      case 0: if ((tt = read_time(value)) > 0) ratelimit->time_stamp = tt;
-		      else printf("bad time value\n");
+	      case 0: if ((tt = read_time(value)) > 0)
+			ratelimit->gen.time_stamp = tt;
+		      else
+			printf("bad time value\n");
 		      break;
 	      case 1: ratelimit->time_usec = Uatoi(value);
 		      break;
@@ -1079,7 +1113,11 @@ for(; (reset_point = store_mark()); store_reset(reset_point))
 	  }
 
 	if (dbdata_type != type_dbm)
-	  ((dbdata_generic *)record)->time_stamp = time(NULL);
+	  {
+	  dbdata_generic * p = (dbdata_generic *)record;
+	  p->time_stamp = time(NULL);
+	  p->tainted = FALSE;
+	  }
 
 	dbfn_write(dbm, name, record, newlength);
 	}
@@ -1179,7 +1217,7 @@ for(; (reset_point = store_mark()); store_reset(reset_point))
 
       case type_ratelimit:
 	ratelimit = (dbdata_ratelimit *)record;
-	printf("0 time stamp:  %s\n", print_time(ratelimit->time_stamp));
+	printf("0 time stamp:  %s\n", print_time(ratelimit->gen.time_stamp));
 	printf("1 fract. time: .%06d\n", ratelimit->time_usec);
 	printf("2 sender rate: % .3f\n", ratelimit->rate);
 	if (Ustrstr(name, "/unique/") != NULL
@@ -1193,8 +1231,8 @@ for(; (reset_point = store_mark()); store_reset(reset_point))
 	break;
 
       case type_tls:
-	session = (dbdata_tls_session *)value;
-	printf("0 time stamp:  %s\n", print_time(session->time_stamp));
+	session = (dbdata_tls_session *)record;
+	printf("0 time stamp:  %s\n", print_time(session->gen.time_stamp));
 	printf("1 session: .%s\n", session->session);
 	break;
 
@@ -1360,10 +1398,10 @@ for (; keychain && (reset_point = store_mark()); store_reset(reset_point))
 
     /* Leave corrupt records alone */
 
-    if (wait->time_stamp > time(NULL))
+    if (wait->gen.time_stamp > time(NULL))
       {
       printf("**** Data for '%s' corrupted\n  time in future: %s\n",
-        key, print_time(((dbdata_generic *)value)->time_stamp));
+        key, print_time(wait->gen.time_stamp));
       continue;
       }
     if (wait->count > WAIT_NAME_MAX)
@@ -1381,7 +1419,7 @@ for (; keychain && (reset_point = store_mark()); store_reset(reset_point))
 
     /* Record over 1 year old; just remove it */
 
-    if (wait->time_stamp < time(NULL) - 365*24*60*60)
+    if (wait->gen.time_stamp < time(NULL) - 365*24*60*60)
       {
       dbfn_delete(dbm, key);
       printf("deleted %s (too old)\n", key);
@@ -1466,7 +1504,8 @@ for (; keychain && (reset_point = store_mark()); store_reset(reset_point))
     if (update)
       {
       printf("updated %s\n", key);
-      wait->time_stamp = time(NULL);
+      wait->gen.time_stamp = time(NULL);
+      /* leave the taint marker unchanged */
       dbfn_write(dbm, key, wait, sizeof(dbdata_wait) +
         wait->count * MESSAGE_ID_LENGTH);
       }
diff --git a/src/src/hintsdb_structs.h b/src/src/hintsdb_structs.h
index c77190f38..f4d72fdc9 100644
--- a/src/src/hintsdb_structs.h
+++ b/src/src/hintsdb_structs.h
@@ -32,7 +32,8 @@ DBM databases are used for hints files.
 
 
 typedef struct {
-  time_t time_stamp;      /* Timestamp of writing */
+  time_t time_stamp;	/* Timestamp of writing */
+  BOOL	 tainted;	/* metadata for the "value" part of the record */
 } dbdata_generic;
 
 
@@ -40,7 +41,7 @@ typedef struct {
 address. */
 
 typedef struct {
-  time_t time_stamp;
+  dbdata_generic gen;
   /*************/
   time_t first_failed;    /* Time of first failure */
   time_t last_try;        /* Time of last try */
@@ -72,7 +73,7 @@ handle the old type of record, we retain the old definition. The different
 kinds of record can be distinguished by their different lengths. */
 
 typedef struct {
-  time_t time_stamp;
+  dbdata_generic gen;
   /*************/
   int   result;
   int   postmaster_result; /* Postmaster is accepted */
@@ -80,7 +81,7 @@ typedef struct {
 } dbdata_callout_cache_obs;
 
 typedef struct {
-  time_t time_stamp;       /* Timestamp of last address check */
+  dbdata_generic gen;		/* Timestamp of last address check */
   /*************/
   int   result;            /* accept or reject */
 } dbdata_callout_cache_address;
@@ -90,7 +91,7 @@ last so that if somebody reverts to an older Exim, the new records will
 still make sense because they match the old layout. */
 
 typedef struct {
-  time_t time_stamp;       /* Time stamp of last connection */
+  dbdata_generic gen;		/* Time stamp of last connection */
   /*************/
   int   result;            /* Domain reject or accept */
   int   postmaster_result; /* Postmaster result */
@@ -103,7 +104,7 @@ typedef struct {
 host for a particular transport. */
 
 typedef struct {
-  time_t time_stamp;
+  dbdata_generic gen;
   /*************/
   int    count;           /* Count of message ids */
   int    sequence;        /* Sequence for continued records */
@@ -123,7 +124,7 @@ at present in use. The same structure is used for recording a running ETRN
 process. */
 
 typedef struct {
-  time_t time_stamp;
+  dbdata_generic gen;
   /*************/
   int    count;           /* Reserved for possible connection count */
 } dbdata_serialize;
@@ -133,7 +134,7 @@ typedef struct {
 ACL condition. */
 
 typedef struct {
-  time_t time_stamp;
+  dbdata_generic gen;
   /*************/
   int    time_usec;       /* Fractional part of time, from gettimeofday() */
   double rate;            /* Smoothed sending rate at that time */
@@ -151,7 +152,7 @@ typedef struct {
 
 /* For "seen" ACL condition */
 typedef struct {
-  time_t time_stamp;
+  dbdata_generic gen;
 } dbdata_seen;
 
 #ifndef DISABLE_PIPE_CONNECT
@@ -174,14 +175,14 @@ typedef struct {
 } ehlo_resp_precis;
 
 typedef struct {
-  time_t time_stamp;
+  dbdata_generic gen;
   /*************/
   ehlo_resp_precis data;
 } dbdata_ehlo_resp;
 #endif
 
 typedef struct {
-  time_t time_stamp;
+  dbdata_generic gen;
   /*************/
   uschar verify_override:1;
   uschar ocsp:3;
diff --git a/src/src/retry.c b/src/src/retry.c
index 24b2fa66a..515c94288 100644
--- a/src/src/retry.c
+++ b/src/src/retry.c
@@ -227,7 +227,7 @@ if (!host_retry_record)
   {
   DEBUG(D_transport|D_retry) debug_printf_indent("no host retry record\n");
   }
-else if (now - host_retry_record->time_stamp > retry_data_expire)
+else if (now - host_retry_record->gen.time_stamp > retry_data_expire)
   {
   host_retry_record = NULL;
   DEBUG(D_transport|D_retry) debug_printf_indent("host retry record too old\n");
@@ -237,7 +237,7 @@ if (!message_retry_record)
   {
   DEBUG(D_transport|D_retry) debug_printf_indent("no message retry record\n");
   }
-else if (now - message_retry_record->time_stamp > retry_data_expire)
+else if (now - message_retry_record->gen.time_stamp > retry_data_expire)
   {
   message_retry_record = NULL;
   DEBUG(D_transport|D_retry)
@@ -744,7 +744,7 @@ for (int i = 0; i < 3; i++)
         retry_record = dbfn_read_with_length(dbm_file, rti->key,
 					      &message_space);
         if (  retry_record
-	   && now - retry_record->time_stamp > retry_data_expire)
+	   && now - retry_record->gen.time_stamp > retry_data_expire)
           retry_record = NULL;
 
         if (!retry_record)
diff --git a/src/src/smtp_in.c b/src/src/smtp_in.c
index 3ffb6fe8b..abc893ddc 100644
--- a/src/src/smtp_in.c
+++ b/src/src/smtp_in.c
@@ -5748,7 +5748,8 @@ while (done <= 0)
       /* Compute the serialization key for this command. We used (all the way
       back to 4.00) to include the given string as part of the key, but this
       opens a security hole for hintsdb types that use a command-string for
-      operations. All ETRN with the same command hash are serialized */
+      operations. So, use a hash of the string. All ETRN with the same command
+      hash are serialized */
 
       md5 hash;
       uschar *digest = store_get(16, GET_TAINTED);
@@ -5756,11 +5757,7 @@ while (done <= 0)
       md5_start(&hash);
       md5_end(&hash, smtp_cmd_argument, Ustrlen(smtp_cmd_argument), digest);
 
-      etrn_serialize_key = string_sprintf("etrn-" /* don't we have a function doing exactly this? */
-          "%02x%02x%02x%02x" "%02x%02x%02x%02x"   /* we have, since 2024-09-xx we can use %.16H */
-          "%02x%02x%02x%02x" "%02x%02x%02x%02x",
-          digest[0], digest[1], digest[2], digest[3], digest[4], digest[5], digest[6], digest[7],
-          digest[8], digest[9], digest[10], digest[11], digest[12], digest[13], digest[14], digest[15]);
+      etrn_serialize_key = string_sprintf("etrn-%.16H", digest);
 
       /* If a command has been specified for running as a result of ETRN, we
       permit any argument to ETRN. If not, only the # standard form is
diff --git a/src/src/tls-openssl.c b/src/src/tls-openssl.c
index 40acee7a3..9d3f5af73 100644
--- a/src/src/tls-openssl.c
+++ b/src/src/tls-openssl.c
@@ -4035,7 +4035,7 @@ if (tlsp->host_resumable)
 #else			/* Use, fairly arbitrilarily, what we as server would */
 	  f.running_in_test_harness ? TESTSUITE_TICKET_LIFE : ssl_session_timeout;
 #endif
-	time_t now = time(NULL), expires = lifetime + dt->time_stamp;
+	time_t now = time(NULL), expires = lifetime + dt->gen.time_stamp;
 	if (expires < now)
 	  {
 	  DEBUG(D_tls) debug_printf("session expired (by " TIME_T_FMT "s from %lus)\n", now - expires, lifetime);
diff --git a/src/src/transports/smtp.c b/src/src/transports/smtp.c
index 8ea3d882a..80a70b490 100644
--- a/src/src/transports/smtp.c
+++ b/src/src/transports/smtp.c
@@ -992,7 +992,7 @@ if (  sx->early_pipe_active
       debug_printf("no ehlo-resp record!\n");
     else
       debug_printf("ehlo-resp record is %.0f seconds old\n",
-		    difftime(time(NULL), er->time_stamp));
+		    difftime(time(NULL), er->gen.time_stamp));
     }
 
   dbfn_delete(dbm_file, ehlo_resp_key);
@@ -1018,7 +1018,7 @@ else
     dbfn_close(dbm_file);
     DEBUG(D_transport) debug_printf("no ehlo-resp record\n");
     }
-  else if (time(NULL) - er->time_stamp > retry_data_expire)
+  else if (time(NULL) - er->gen.time_stamp > retry_data_expire)
     {
     DEBUG(D_transport) debug_printf("ehlo-resp record too old\n");
     dbfn_close(dbm_file);
diff --git a/src/src/verify.c b/src/src/verify.c
index 6696ec4d9..be9ea7fe4 100644
--- a/src/src/verify.c
+++ b/src/src/verify.c
@@ -63,7 +63,7 @@ negative = cache_record->result != ccache_accept ||
 expire = negative? negative_expire : positive_expire;
 now = time(NULL);
 
-if (now - cache_record->time_stamp > expire)
+if (now - cache_record->gen.time_stamp > expire)
   {
   HDEBUG(D_verify) debug_printf_indent("callout cache: %s record expired for %s\n", type, key);
   return NULL;
@@ -81,7 +81,7 @@ if (type[0] == 'd' && cache_record->result != ccache_reject)
     {
     dbdata_callout_cache * new = store_get(sizeof(dbdata_callout_cache), GET_UNTAINTED);
     memcpy(new, cache_record, length);
-    new->postmaster_stamp = new->random_stamp = new->time_stamp;
+    new->postmaster_stamp = new->random_stamp = new->gen.time_stamp;
     cache_record = new;
     }
 

